> ## Documentation Index
> Fetch the complete documentation index at: https://docs.stigg.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Get a list of contracts

> Retrieves a customer's contracts, fetched live from the connected billing provider, each enriched with a preview of its upcoming (next) invoice when available. Returns an empty list when no billing provider is connected or the customer is not synced.



## OpenAPI

````yaml https://app.stainless.com/api/spec/documented/stigg/openapi.documented.yml get /api/v1/customers/{id}/contracts
openapi: 3.0.0
info:
  title: Stigg API
  description: Stigg API documentation
  version: 7.129.2
  contact: {}
servers:
  - url: https://api.stigg.io
    description: Production
security:
  - ApiKeyAuth: []
tags:
  - name: Customers
    description: Operations related to customers
  - name: Subscriptions
    description: Operations related to subscriptions
  - name: Coupons
    description: Operations related to coupons
  - name: Bulk Import
    description: Operations related to import of customers and subscriptions
  - name: Usage
    description: Operations related to usage & metering
  - name: Promotional Entitlements
    description: Operations related to promotional entitlements
  - name: Products
    description: Operations related to products
  - name: Features
    description: Operations related to features
  - name: Addons
    description: Operations related to addons
  - name: Plans
    description: Operations related to plans
  - name: Credit grants
    description: Operations related to credit grants
  - name: Credit ledger
    description: Operations related to credit ledger
  - name: Custom currencies
    description: Operations related to custom currencies
paths:
  /api/v1/customers/{id}/contracts:
    get:
      tags:
        - Contracts
      summary: Get a list of contracts
      description: >-
        Retrieves a customer's contracts, fetched live from the connected
        billing provider, each enriched with a preview of its upcoming (next)
        invoice when available. Returns an empty list when no billing provider
        is connected or the customer is not synced.
      operationId: CustomerContractsController_getCustomerContracts
      parameters:
        - name: id
          required: true
          in: path
          description: The external identifier of the customer the contract belongs to
          schema:
            minLength: 1
            maxLength: 255
            pattern: ^[a-zA-Z0-9][a-zA-Z0-9_|.@-]*$
            type: string
        - name: X-ACCOUNT-ID
          in: header
          description: >-
            Account ID — optional when authenticating with a user JWT (Bearer
            token); falls back to the user's first membership. Ignored for
            API-key auth.
          required: false
          schema:
            type: string
        - name: X-ENVIRONMENT-ID
          in: header
          description: >-
            Environment ID — required when authenticating with a user JWT
            (Bearer token) on environment-scoped endpoints. Ignored for API-key
            auth (env is intrinsic to the key).
          required: false
          schema:
            type: string
      responses:
        '200':
          description: >-
            The customer's contracts, each with its next-invoice preview when
            available.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CustomerContractsListResponseDto'
              examples:
                default:
                  value:
                    data:
                      - contractId: contract-acme-2026
                        billingId: ct_1a2b3c4d
                        id: 3452155b-deca-4d7f-91e5-82d486dc8bb0
                        refId: contract-acme-2026
                        poNumber: PO-4821
                        externalId: contract-acme-2026
                        customerExternalId: customer-acme
                        name: PO-4821
                        state: ACTIVE
                        activationStartDate: '2026-01-01T00:00:00.000Z'
                        activationEndDate: '2026-12-31T00:00:00.000Z'
                        createdAt: '2025-12-15T09:30:00.000Z'
                        nextInvoice:
                          amount:
                            amount: 4900
                            currency: usd
                          dueDate: '2026-08-01T00:00:00.000Z'
                          periodStart: '2026-07-01T00:00:00.000Z'
                          periodEnd: '2026-08-01T00:00:00.000Z'
                        latestInvoice:
                          billingId: inv_abc123
                          status: OPEN
                          createdAt: '2026-07-01T00:00:00.000Z'
                          total: 4900
                          amountDue: 4900
                          currency: usd
                          pdfUrl: null
                          requiresAction: false
                          billingReason: null
                        subscriptions:
                          - subscriptionId: subscription-acme-platform
                            planDisplayName: Enterprise Platform
                            productDisplayName: Revvenu
        '400':
          description: bad request.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadInputErrorResponseDto'
        '401':
          description: User is not authenticated.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UnauthenticatedErrorResponseDto'
        '403':
          description: User is not allowed to access this resource.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ForbiddenErrorResponseDto'
        '429':
          description: Too many requests.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TooManyRequestsErrorResponseDto'
      x-codeSamples:
        - lang: JavaScript
          source: |-
            import Stigg from '@stigg/typescript';

            const client = new Stigg({
              apiKey: process.env['STIGG_API_KEY'], // This is the default and can be omitted
            });

            const response = await client.v1.customers.listContracts('id');

            console.log(response.data);
        - lang: Python
          source: |-
            import os
            from stigg import Stigg

            client = Stigg(
                api_key=os.environ.get("STIGG_API_KEY"),  # This is the default and can be omitted
            )
            response = client.v1.customers.list_contracts(
                id="id",
            )
            print(response.data)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/stiggio/stigg-go\"\n\t\"github.com/stiggio/stigg-go/option\"\n)\n\nfunc main() {\n\tclient := stigg.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tresponse, err := client.V1.Customers.ListContracts(\n\t\tcontext.TODO(),\n\t\t\"id\",\n\t\tstigg.V1CustomerListContractsParams{},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", response.Data)\n}\n"
        - lang: Java
          source: |-
            package io.stigg.example;

            import io.stigg.client.StiggClient;
            import io.stigg.client.okhttp.StiggOkHttpClient;
            import io.stigg.models.v1.customers.CustomerListContractsParams;
            import io.stigg.models.v1.customers.CustomerListContractsResponse;

            public final class Main {
                private Main() {}

                public static void main(String[] args) {
                    StiggClient client = StiggOkHttpClient.fromEnv();

                    CustomerListContractsResponse response = client.v1().customers().listContracts("id");
                }
            }
        - lang: Ruby
          source: |-
            require "stigg"

            stigg = Stigg::Client.new(api_key: "My API Key")

            response = stigg.v1.customers.list_contracts("id")

            puts(response)
        - lang: C#
          source: |-
            using System;
            using Stigg.Client;
            using Stigg.Client.Models.V1.Customers;

            StiggClient client = new();

            CustomerListContractsParams parameters = new() { ID = "id" };

            var response = await client.V1.Customers.ListContracts(parameters);

            Console.WriteLine(response);
        - lang: CLI
          source: |-
            stigg v1:customers list-contracts \
              --api-key 'My API Key' \
              --id id
components:
  schemas:
    CustomerContractsListResponseDto:
      type: object
      properties:
        data:
          type: array
          items:
            type: object
            properties:
              contractId:
                type: string
                maxLength: 255
                description: >-
                  The Stigg contract ref ID (the key used to fetch/update/delete
                  this contract)
              billingId:
                type: string
                maxLength: 255
                description: >-
                  The billing provider (Received) contract ID; null until the
                  contract has synced to the billing provider
                nullable: true
              id:
                type: string
                maxLength: 255
                description: >-
                  The persisted Stigg contract id (matches a subscription’s
                  contractId; present for Stigg-managed contracts)
                nullable: true
              refId:
                type: string
                maxLength: 255
                description: >-
                  The Stigg contract ref ID (present for Stigg-managed
                  contracts; the key used to update/delete)
                nullable: true
              poNumber:
                type: string
                maxLength: 255
                description: Purchase-order number, when set on the contract
                nullable: true
              externalId:
                type: string
                maxLength: 255
                description: The external identifier of the contract
              customerExternalId:
                type: string
                maxLength: 255
                description: >-
                  The external identifier of the customer the contract belongs
                  to
                nullable: true
              name:
                type: string
                maxLength: 255
                description: >-
                  The contract name (the purchase-order number when set,
                  otherwise the contract/customer name)
                nullable: true
              state:
                type: string
                enum:
                  - DRAFT
                  - ACTIVE
                  - CANCELED
                  - END_BILLING
                description: The current state of the contract
              activationStartDate:
                type: string
                format: date-time
                description: The date the contract becomes active
                nullable: true
              activationEndDate:
                type: string
                format: date-time
                description: The date the contract activation ends
                nullable: true
              createdAt:
                type: string
                format: date-time
                description: The date the contract was created
                nullable: true
              nextInvoice:
                type: object
                properties:
                  amount:
                    type: object
                    properties:
                      amount:
                        type: number
                        description: The price amount
                      currency:
                        description: ISO 4217 currency code
                        type: string
                        enum:
                          - usd
                          - aed
                          - all
                          - amd
                          - ang
                          - aud
                          - awg
                          - azn
                          - bam
                          - bbd
                          - bdt
                          - bgn
                          - bif
                          - bmd
                          - bnd
                          - bsd
                          - bwp
                          - byn
                          - bzd
                          - brl
                          - cad
                          - cdf
                          - chf
                          - cny
                          - czk
                          - dkk
                          - dop
                          - dzd
                          - egp
                          - etb
                          - eur
                          - fjd
                          - gbp
                          - gel
                          - gip
                          - gmd
                          - gyd
                          - hkd
                          - hrk
                          - htg
                          - idr
                          - ils
                          - inr
                          - isk
                          - jmd
                          - jpy
                          - kes
                          - kgs
                          - khr
                          - kmf
                          - krw
                          - kyd
                          - kzt
                          - lbp
                          - lkr
                          - lrd
                          - lsl
                          - mad
                          - mdl
                          - mga
                          - mkd
                          - mmk
                          - mnt
                          - mop
                          - mro
                          - mvr
                          - mwk
                          - mxn
                          - myr
                          - mzn
                          - nad
                          - ngn
                          - nok
                          - npr
                          - nzd
                          - pgk
                          - php
                          - pkr
                          - pln
                          - qar
                          - ron
                          - rsd
                          - rub
                          - rwf
                          - sar
                          - sbd
                          - scr
                          - sek
                          - sgd
                          - sle
                          - sll
                          - sos
                          - szl
                          - thb
                          - tjs
                          - top
                          - try
                          - ttd
                          - tzs
                          - uah
                          - uzs
                          - vnd
                          - vuv
                          - wst
                          - xaf
                          - xcd
                          - yer
                          - zar
                          - zmw
                          - clp
                          - djf
                          - gnf
                          - ugx
                          - pyg
                          - xof
                          - xpf
                        title: Currency
                    required:
                      - amount
                      - currency
                    description: The total amount of the upcoming invoice
                  dueDate:
                    type: string
                    format: date-time
                    description: The date the upcoming invoice is due
                    nullable: true
                  periodStart:
                    type: string
                    format: date-time
                    description: >-
                      The start of the billing period the upcoming invoice
                      covers
                    nullable: true
                  periodEnd:
                    type: string
                    format: date-time
                    description: The end of the billing period the upcoming invoice covers
                    nullable: true
                required:
                  - amount
                  - dueDate
                  - periodStart
                  - periodEnd
                title: ContractNextInvoice
                description: >-
                  A preview of the contract's upcoming invoice, or null when
                  none is available
                nullable: true
              latestInvoice:
                type: object
                properties:
                  billingId:
                    type: string
                    maxLength: 255
                    description: Invoice billing ID
                  status:
                    type: string
                    enum:
                      - OPEN
                      - CANCELED
                      - PAID
                    description: Invoice status
                  createdAt:
                    type: string
                    format: date-time
                    description: Invoice creation date
                  total:
                    type: number
                    description: Total amount
                    nullable: true
                  amountDue:
                    type: number
                    description: Amount due
                    nullable: true
                  currency:
                    type: string
                    maxLength: 255
                    description: Invoice currency
                    nullable: true
                  pdfUrl:
                    type: string
                    maxLength: 255
                    description: Invoice PDF URL
                    nullable: true
                  requiresAction:
                    type: boolean
                    description: Whether payment requires action
                  billingReason:
                    type: string
                    enum:
                      - BILLING_CYCLE
                      - SUBSCRIPTION_CREATION
                      - SUBSCRIPTION_UPDATE
                      - MANUAL
                      - MINIMUM_INVOICE_AMOUNT_EXCEEDED
                      - OTHER
                    nullable: true
                    description: Billing reason
                required:
                  - billingId
                  - status
                  - createdAt
                  - requiresAction
                title: LatestInvoice
                description: >-
                  The most recent non-draft invoice for this contract (open,
                  paid, or canceled), or null when none exists
                nullable: true
              subscriptions:
                type: array
                items:
                  type: object
                  properties:
                    subscriptionId:
                      type: string
                      maxLength: 255
                      description: >-
                        The subscription ref ID (use it to deep-link to the
                        subscription)
                    planDisplayName:
                      type: string
                      maxLength: 255
                      description: Display name of the subscription plan
                      nullable: true
                    productDisplayName:
                      type: string
                      maxLength: 255
                      description: >-
                        Display name of the product the subscription plan
                        belongs to
                      nullable: true
                  required:
                    - subscriptionId
                    - planDisplayName
                    - productDisplayName
                  title: ContractSubscriptionRef
                  description: A custom subscription attached to a contract.
                description: >-
                  The custom subscriptions attached to this contract (empty when
                  none)
            required:
              - contractId
              - billingId
              - id
              - refId
              - poNumber
              - externalId
              - customerExternalId
              - name
              - state
              - activationStartDate
              - activationEndDate
              - createdAt
              - nextInvoice
              - latestInvoice
              - subscriptions
            title: Contract
            description: A billing contract as reported by the connected billing provider.
      required:
        - data
      title: CustomerContractsListResponse
      description: A list of a customer's contracts
    BadInputErrorResponseDto:
      type: object
      properties:
        message:
          type: string
        code:
          type: string
          enum:
            - BadUserInput
            - DuplicateIntegrationNotAllowed
            - EntityIsArchivedError
            - IntegrityViolation
            - FreePlanCantHaveCompatiblePackageGroupError
            - SubscriptionMustHaveSinglePlanError
            - AddonIsCompatibleWithPlan
            - AddonIsCompatibleWithGroup
            - DuplicateAddonProvisionedError
            - ScheduledMigrationAlreadyExistsError
            - SubscriptionAlreadyOnLatestPlan
            - EntityIdDifferentFromRefIdError
            - UnsupportedFeatureType
            - UnsupportedVendorIdentifier
            - UnsupportedSubscriptionScheduleType
            - InvalidEntitlementResetPeriod
            - IncompatibleSubscriptionAddon
            - UnPublishedPackage
            - MeteringNotAvailableForFeatureType
            - AuthCustomerMismatch
            - AuthCustomerReadonly
            - FetchAllCountriesPricesNotAllowed
            - MemberInvitationError
            - PlansCircularDependencyError
            - NoFeatureEntitlementInSubscription
            - CheckoutIsNotSupported
            - UnsupportedParameter
            - PricingModelNotSupportedByBillingIntegration
            - BillingIntegrationMissing
            - BillingIntegrationAlreadyExistsError
            - InvalidMemberDelete
            - PackageAlreadyPublished
            - DraftPlanCantBeArchived
            - DraftAddonCantBeArchived
            - PlanWithChildCantBeDeleted
            - PlanCannotBePublishWhenBasePlanIsDraft
            - PlanCannotBePublishWhenCompatibleAddonIsDraft
            - PlanIsUsedAsDefaultStartPlan
            - PlanIsUsedAsDowngradePlan
            - InvalidAddressError
            - InvalidQuantity
            - BillingPeriodMissingError
            - DowngradeBillingPeriodNotSupportedError
            - CustomerAlreadyUsesCouponError
            - CustomerAlreadyHaveCustomerCoupon
            - SubscriptionAlreadyCanceledOrExpired
            - TrialMustBeCancelledImmediately
            - SubscriptionDoesNotHaveBillingPeriod
            - InvalidCancellationDate
            - FailedToImportCustomer
            - FailedToImportSubscriptions
            - PackagePricingTypeNotSet
            - InvalidSubscriptionStatus
            - InvalidArgumentError
            - EditAllowedOnDraftPackageOnlyError
            - ResyncAlreadyInProgress
            - ArchivedCouponCantBeApplied
            - ImportAlreadyInProgress
            - AddonHasToHavePriceError
            - SelectedBillingModelDoesntMatchImportedItemError
            - CannotArchiveProductError
            - CannotUnarchiveProductError
            - CannotDeleteCustomerError
            - CannotRemovePaymentMethodFromCustomerError
            - CannotDeleteFeatureError
            - CannotArchiveFeatureError
            - InvalidUpdatePriceUnitAmountError
            - ExperimentAlreadyRunning
            - ExperimentStatusError
            - OperationNotAllowedDuringInProgressExperiment
            - EntitlementsMustBelongToSamePackage
            - CanNotUpdateEntitlementsFeatureGroup
            - MeterMustBeAssociatedToMeteredFeature
            - CannotEditPackageInNonDraftMode
            - CannotAddOverrideEntitlementToPlan
            - MissingEntityIdError
            - NoProductsAvailable
            - PromotionCodeNotForCustomer
            - PromotionCodeNotActive
            - PromotionCodeMaxRedemptionsReached
            - PromotionCodeMinimumAmountNotReached
            - PromotionCodeCustomerNotFirstPurchase
            - AddonWithDraftCannotBeDeletedError
            - CannotReportUsageForEntitlementWithMeterError
            - RecalculateEntitlementsError
            - ImportSubscriptionsBulkError
            - InvalidMetadataError
            - CannotUpsertToPackageThatHasDraft
            - IntegrationValidationError
            - AwsMarketplaceIntegrationValidationError
            - AwsMarketplaceIntegrationError
            - DataExportIntegrationError
            - HubspotIntegrationError
            - DuplicateProductValidationError
            - AmountTooLarge
            - CustomerHasNoEmailAddress
            - MergeEnvironmentValidationError
            - EntitlementLimitExceededError
            - EntitlementUsageOutOfRangeError
            - UsageMeasurementDiffOutOfRangeError
            - AddonQuantityExceedsLimitError
            - AddonDependencyMissingError
            - PackageGroupMinItemsError
            - CannotUpdateUnitTransformationError
            - SingleSubscriptionCantBeAutoCancellationTargetError
            - MultiSubscriptionCantBeAutoCancellationSourceError
            - ChangingPayingCustomerIsNotSupportedError
            - RequiredSsoAuthenticationError
            - InvalidDoggoSignatureError
            - InvalidReceivedSignatureError
            - CannotDeleteDefaultIntegration
            - CannotChangeBillingIntegration
            - FailedToResolveBillingIntegration
            - WorkflowTriggerNotFound
            - DeprecatedEstimateSubscriptionError
            - FeatureConfigurationExceededLimitError
            - FeatureNotBelongToFeatureGroupError
            - FeatureGroupMissingFeaturesError
            - VersionExceedsMaxValueError
            - CannotUpdateExpireAtForExpiredCreditGrantError
            - ExpireAtMustBeLaterThanEffectiveAtError
            - OfferAlreadyExists
            - DraftAlreadyExists
            - CreditGrantAlreadyVoided
            - CreditGrantCannotBeVoided
            - InvalidTaxId
            - ObjectAlreadyBeingUsedByAnotherRequestError
            - TooManySubscriptionsPerCustomer
            - TooManyCustomCurrencies
            - StripeError
            - SchedulingAtEndOfBillingPeriod
            - ApiKeyExpired
            - ApiKeyHasExpiry
            - OveragePriceNotSupportedOnAddon
            - OveragePriceRequiresUsageLimit
            - InvalidCreditOverageBillingModel
            - CreditOveragePriceCurrencyNotFound
            - InvoicePreviewNotAvailableForDraftContract
          nullable: true
      required:
        - message
        - code
    UnauthenticatedErrorResponseDto:
      type: object
      properties:
        message:
          type: string
        code:
          type: string
          enum:
            - Unauthenticated
          nullable: true
      required:
        - message
        - code
    ForbiddenErrorResponseDto:
      type: object
      properties:
        message:
          type: string
        code:
          type: string
          enum:
            - IdentityForbidden
            - AccessDeniedError
            - NoFeatureEntitlementError
            - GovernanceNotEnabled
          nullable: true
      required:
        - message
        - code
    TooManyRequestsErrorResponseDto:
      type: object
      properties:
        message:
          type: string
        code:
          type: string
          enum:
            - RateLimitExceeded
          nullable: true
      required:
        - message
        - code
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: X-API-KEY
      description: Server API Key

````